Index: /inundation/zeus/Merimbula.zpi
===================================================================
--- /inundation/zeus/Merimbula.zpi	(revision 1727)
+++ /inundation/zeus/Merimbula.zpi	(revision 1727)
@@ -0,0 +1,81 @@
+<!-- Project file for the Zeus for Windows editor.-->
+<project name="Merimbula">
+    <SccEnable>Off</SccEnable>
+    <SccComment></SccComment>
+    <SccProject></SccProject>
+    <SccAuxPath></SccAuxPath>
+    <SccLocalPath></SccLocalPath>
+    <TagEnable>On</TagEnable>
+    <TagNone>Off</TagNone>
+    <TagVariable>On</TagVariable>
+    <TagFunction>On</TagFunction>
+    <TagBuildNone>Off</TagBuildNone>
+    <TagBuildOnOpen>On</TagBuildOnOpen>
+    <TagBuildOnSave>On</TagBuildOnSave>
+    <TagInterval>6</TagInterval>
+    <Server></Server>
+    <UserID></UserID>
+    <Password></Password>
+    <LocalDir></LocalDir>
+    <RemoteDir></RemoteDir>
+    <Classes>Classes</Classes>
+    <Enumerations>Enumerations</Enumerations>
+    <Files>ProjectFiles</Files>
+    <Functions>Functions</Functions>
+    <Interfaces>Interfaces</Interfaces>
+    <Macros>Macros</Macros>
+    <Packages>Packages</Packages>
+    <References>References</References>
+    <Structures>Structures</Structures>
+    <Typedefs>Typedefs</Typedefs>
+    <Variables>Variables</Variables>
+    <MakeFile></MakeFile>
+    <SearchPath></SearchPath>
+    <RegexFile></RegexFile>
+    <RegexLine></RegexLine>
+    <RegexInfo></RegexInfo>
+    <RegexError></RegexError>
+    <RegexWarning></RegexWarning>
+    <DebugExecutable></DebugExecutable>
+    <DebugArguments></DebugArguments>
+    <DebugDirectory></DebugDirectory>
+    <DebugDebugger></DebugDebugger>
+    <ReleaseExecutable></ReleaseExecutable>
+    <ReleaseArguments></ReleaseArguments>
+    <ReleaseDirectory></ReleaseDirectory>
+    <ReleaseDebugger></ReleaseDebugger>
+    <DebugMake></DebugMake>
+    <DebugClean></DebugClean>
+    <DebugCompile></DebugCompile>
+    <DebugRebuild></DebugRebuild>
+    <DebugProjectOutput></DebugProjectOutput>
+    <DebugCompilerOutput></DebugCompilerOutput>
+    <DebugCompilerStdOut>On</DebugCompilerStdOut>
+    <DebugCompilerStdErr>On</DebugCompilerStdErr>
+    <DebugCompilerSaveAll>Off</DebugCompilerSaveAll>
+    <DebugCompilerReload>Off</DebugCompilerReload>
+    <DebugProjectStdOut>On</DebugProjectStdOut>
+    <DebugProjectStdErr>On</DebugProjectStdErr>
+    <DebugProjectSaveAll>Off</DebugProjectSaveAll>
+    <DebugProjectReload>Off</DebugProjectReload>
+    <ReleaseMake></ReleaseMake>
+    <ReleaseClean></ReleaseClean>
+    <ReleaseCompile></ReleaseCompile>
+    <ReleaseRebuild></ReleaseRebuild>
+    <ReleaseProjectOutput></ReleaseProjectOutput>
+    <ReleaseCompilerOutput></ReleaseCompilerOutput>
+    <ReleaseCompilerStdOut>On</ReleaseCompilerStdOut>
+    <ReleaseCompilerStdErr>On</ReleaseCompilerStdErr>
+    <ReleaseCompilerSaveAll>Off</ReleaseCompilerSaveAll>
+    <ReleaseCompilerReload>Off</ReleaseCompilerReload>
+    <ReleaseProjectStdOut>On</ReleaseProjectStdOut>
+    <ReleaseProjectStdErr>On</ReleaseProjectStdErr>
+    <ReleaseProjectSaveAll>Off</ReleaseProjectSaveAll>
+    <ReleaseProjectReload>Off</ReleaseProjectReload>
+    <file>..\merimbula\run_least_squares_merimbula.py</file>
+    <file>..\merimbula\run_merimbula_lake.py</file>
+    <file>..\merimbula\run_merimbula_lake_checkpoint.py</file>
+    <folder name="Header Files" />
+    <folder name="Resource Files" />
+    <folder name="Source Files" />
+</project>
Index: /inundation/zeus/anuga-workspace.zwi
===================================================================
--- /inundation/zeus/anuga-workspace.zwi	(revision 1727)
+++ /inundation/zeus/anuga-workspace.zwi	(revision 1727)
@@ -0,0 +1,9 @@
+<!-- Workspace file for the Zeus for Windows editor.-->
+<workspace name="anuga-workspace">
+    <mode>Debug</mode>
+    <active>parallel</active>
+    <project name="Merimbula">Merimbula.zpi</project>
+    <project name="parallel">parallel.zpi</project>
+    <project name="pyvolution">pyvolution.zpi</project>
+    <project name="steve">steve.zpi</project>
+</workspace>
Index: /inundation/zeus/parallel.zpi
===================================================================
--- /inundation/zeus/parallel.zpi	(revision 1727)
+++ /inundation/zeus/parallel.zpi	(revision 1727)
@@ -0,0 +1,93 @@
+<!-- Project file for the Zeus for Windows editor.-->
+<project name="parallel">
+    <SccEnable>Off</SccEnable>
+    <SccComment></SccComment>
+    <SccProject></SccProject>
+    <SccAuxPath></SccAuxPath>
+    <SccLocalPath></SccLocalPath>
+    <TagEnable>On</TagEnable>
+    <TagNone>Off</TagNone>
+    <TagVariable>On</TagVariable>
+    <TagFunction>On</TagFunction>
+    <TagBuildNone>Off</TagBuildNone>
+    <TagBuildOnOpen>On</TagBuildOnOpen>
+    <TagBuildOnSave>On</TagBuildOnSave>
+    <TagInterval>6</TagInterval>
+    <Server></Server>
+    <UserID></UserID>
+    <Password></Password>
+    <LocalDir></LocalDir>
+    <RemoteDir></RemoteDir>
+    <Classes>Classes</Classes>
+    <Enumerations>Enumerations</Enumerations>
+    <Files>ProjectFiles</Files>
+    <Functions>Functions</Functions>
+    <Interfaces>Interfaces</Interfaces>
+    <Macros>Macros</Macros>
+    <Packages>Packages</Packages>
+    <References>References</References>
+    <Structures>Structures</Structures>
+    <Typedefs>Typedefs</Typedefs>
+    <Variables>Variables</Variables>
+    <MakeFile></MakeFile>
+    <SearchPath></SearchPath>
+    <RegexFile></RegexFile>
+    <RegexLine></RegexLine>
+    <RegexInfo></RegexInfo>
+    <RegexError></RegexError>
+    <RegexWarning></RegexWarning>
+    <DebugExecutable></DebugExecutable>
+    <DebugArguments></DebugArguments>
+    <DebugDirectory></DebugDirectory>
+    <DebugDebugger></DebugDebugger>
+    <ReleaseExecutable></ReleaseExecutable>
+    <ReleaseArguments></ReleaseArguments>
+    <ReleaseDirectory></ReleaseDirectory>
+    <ReleaseDebugger></ReleaseDebugger>
+    <DebugMake></DebugMake>
+    <DebugClean></DebugClean>
+    <DebugCompile></DebugCompile>
+    <DebugRebuild></DebugRebuild>
+    <DebugProjectOutput></DebugProjectOutput>
+    <DebugCompilerOutput></DebugCompilerOutput>
+    <DebugCompilerStdOut>On</DebugCompilerStdOut>
+    <DebugCompilerStdErr>On</DebugCompilerStdErr>
+    <DebugCompilerSaveAll>Off</DebugCompilerSaveAll>
+    <DebugCompilerReload>Off</DebugCompilerReload>
+    <DebugProjectStdOut>On</DebugProjectStdOut>
+    <DebugProjectStdErr>On</DebugProjectStdErr>
+    <DebugProjectSaveAll>Off</DebugProjectSaveAll>
+    <DebugProjectReload>Off</DebugProjectReload>
+    <ReleaseMake></ReleaseMake>
+    <ReleaseClean></ReleaseClean>
+    <ReleaseCompile></ReleaseCompile>
+    <ReleaseRebuild></ReleaseRebuild>
+    <ReleaseProjectOutput></ReleaseProjectOutput>
+    <ReleaseCompilerOutput></ReleaseCompilerOutput>
+    <ReleaseCompilerStdOut>On</ReleaseCompilerStdOut>
+    <ReleaseCompilerStdErr>On</ReleaseCompilerStdErr>
+    <ReleaseCompilerSaveAll>Off</ReleaseCompilerSaveAll>
+    <ReleaseCompilerReload>Off</ReleaseCompilerReload>
+    <ReleaseProjectStdOut>On</ReleaseProjectStdOut>
+    <ReleaseProjectStdErr>On</ReleaseProjectStdErr>
+    <ReleaseProjectSaveAll>Off</ReleaseProjectSaveAll>
+    <ReleaseProjectReload>Off</ReleaseProjectReload>
+    <file>..\parallel\build_commun.py</file>
+    <file>..\parallel\build_local.py</file>
+    <file>..\parallel\build_submesh.py</file>
+    <file>..\parallel\mg2ga.py</file>
+    <file>..\parallel\parallel_advection.py</file>
+    <file>..\parallel\parallel_meshes.py</file>
+    <file>..\parallel\parallel_shallow_water.py</file>
+    <file>..\parallel\pmesh_divide.py</file>
+    <file>..\parallel\run_advection.py</file>
+    <file>..\parallel\run_parallel_advection.py</file>
+    <file>..\parallel\run_parallel_merimbula.py</file>
+    <file>..\parallel\run_parallel_mesh.py</file>
+    <file>..\parallel\run_parallel_sw_merimbula.py</file>
+    <file>..\parallel\run_parallel_sw_rectangle.py</file>
+    <file>..\parallel\run_sw_lost_mass.py</file>
+    <folder name="Header Files" />
+    <folder name="Resource Files" />
+    <folder name="Source Files" />
+</project>
Index: /inundation/zeus/pyvolution.zpi
===================================================================
--- /inundation/zeus/pyvolution.zpi	(revision 1727)
+++ /inundation/zeus/pyvolution.zpi	(revision 1727)
@@ -0,0 +1,146 @@
+<!-- Project file for the Zeus for Windows editor.-->
+<project name="pyvolution">
+    <SccEnable>On</SccEnable>
+    <SccComment></SccComment>
+    <SccProject></SccProject>
+    <SccAuxPath></SccAuxPath>
+    <SccLocalPath></SccLocalPath>
+    <TagEnable>On</TagEnable>
+    <TagNone>Off</TagNone>
+    <TagVariable>On</TagVariable>
+    <TagFunction>On</TagFunction>
+    <TagBuildNone>Off</TagBuildNone>
+    <TagBuildOnOpen>On</TagBuildOnOpen>
+    <TagBuildOnSave>On</TagBuildOnSave>
+    <TagInterval>6</TagInterval>
+    <Server></Server>
+    <UserID></UserID>
+    <Password></Password>
+    <LocalDir></LocalDir>
+    <RemoteDir></RemoteDir>
+    <Classes>Classes</Classes>
+    <Enumerations>Enumerations</Enumerations>
+    <Files>Project Files</Files>
+    <Functions>Functions</Functions>
+    <Interfaces>Interfaces</Interfaces>
+    <Macros>Macros</Macros>
+    <Packages>Packages</Packages>
+    <References>References</References>
+    <Structures>Structures</Structures>
+    <Typedefs>Typedefs</Typedefs>
+    <Variables>Variables</Variables>
+    <MakeFile>makefile</MakeFile>
+    <SearchPath></SearchPath>
+    <RegexFile></RegexFile>
+    <RegexLine></RegexLine>
+    <RegexInfo></RegexInfo>
+    <RegexError></RegexError>
+    <RegexWarning></RegexWarning>
+    <DebugExecutable></DebugExecutable>
+    <DebugArguments></DebugArguments>
+    <DebugDirectory></DebugDirectory>
+    <DebugDebugger></DebugDebugger>
+    <ReleaseExecutable></ReleaseExecutable>
+    <ReleaseArguments></ReleaseArguments>
+    <ReleaseDirectory></ReleaseDirectory>
+    <ReleaseDebugger></ReleaseDebugger>
+    <DebugMake>make $PF</DebugMake>
+    <DebugClean>make clean</DebugClean>
+    <DebugCompile></DebugCompile>
+    <DebugRebuild>make $PF</DebugRebuild>
+    <DebugProjectOutput>Always</DebugProjectOutput>
+    <DebugCompilerOutput>Always</DebugCompilerOutput>
+    <DebugCompilerStdOut>On</DebugCompilerStdOut>
+    <DebugCompilerStdErr>On</DebugCompilerStdErr>
+    <DebugCompilerSaveAll>Off</DebugCompilerSaveAll>
+    <DebugCompilerReload>Off</DebugCompilerReload>
+    <DebugProjectStdOut>On</DebugProjectStdOut>
+    <DebugProjectStdErr>On</DebugProjectStdErr>
+    <DebugProjectSaveAll>Off</DebugProjectSaveAll>
+    <DebugProjectReload>Off</DebugProjectReload>
+    <ReleaseMake>make $ws</ReleaseMake>
+    <ReleaseClean>make clean</ReleaseClean>
+    <ReleaseCompile></ReleaseCompile>
+    <ReleaseRebuild>rebuild $ws</ReleaseRebuild>
+    <ReleaseProjectOutput>Always</ReleaseProjectOutput>
+    <ReleaseCompilerOutput>Always</ReleaseCompilerOutput>
+    <ReleaseCompilerStdOut>On</ReleaseCompilerStdOut>
+    <ReleaseCompilerStdErr>On</ReleaseCompilerStdErr>
+    <ReleaseCompilerSaveAll>Off</ReleaseCompilerSaveAll>
+    <ReleaseCompilerReload>Off</ReleaseCompilerReload>
+    <ReleaseProjectStdOut>On</ReleaseProjectStdOut>
+    <ReleaseProjectStdErr>On</ReleaseProjectStdErr>
+    <ReleaseProjectSaveAll>Off</ReleaseProjectSaveAll>
+    <ReleaseProjectReload>Off</ReleaseProjectReload>
+    <file>..\pyvolution\advection.py</file>
+    <file>..\pyvolution\bed_w_eden_boundary.py</file>
+    <file>..\pyvolution\bed_w_file_boundary.py</file>
+    <file>..\pyvolution\cg_solve.py</file>
+    <file>..\pyvolution\check_sww_tsh.py</file>
+    <file>..\pyvolution\combine_pts.py</file>
+    <file>..\pyvolution\compile.py</file>
+    <file>..\pyvolution\config.py</file>
+    <file>..\pyvolution\cornell_room.py</file>
+    <file>..\pyvolution\data_manager.py</file>
+    <file>..\pyvolution\domain.py</file>
+    <file>..\pyvolution\flatbed.py</file>
+    <file>..\pyvolution\flatbed_compare.py</file>
+    <file>..\pyvolution\general_mesh.py</file>
+    <file>..\pyvolution\generic_boundary_conditions.py</file>
+    <file>..\pyvolution\interpolate_sww.py</file>
+    <file>..\pyvolution\island.py</file>
+    <file>..\pyvolution\least_squares.py</file>
+    <file>..\pyvolution\load_mesh\loadASCII.py</file>
+    <file>..\pyvolution\log.ini</file>
+    <file>..\pyvolution\mesh.py</file>
+    <file>..\pyvolution\mesh_factory.py</file>
+    <file>..\pyvolution\most2nc.py</file>
+    <file>..\pyvolution\netherlands.py</file>
+    <file>..\pyvolution\netherlands-chris.py</file>
+    <file>..\pyvolution\normalDate.py</file>
+    <file>..\pyvolution\pmesh2domain.py</file>
+    <file>..\pyvolution\pressure_force.py</file>
+    <file>..\pyvolution\quad.py</file>
+    <file>..\pyvolution\quantity.py</file>
+    <file>..\pyvolution\quantity_ext.c</file>
+    <file>..\pyvolution\realtime_visualisation.py</file>
+    <file>..\pyvolution\realtime_visualisation_new.py</file>
+    <file>..\pyvolution\region.py</file>
+    <file>..\pyvolution\run_profile.py</file>
+    <file>..\pyvolution\run_tsh_weir.py</file>
+    <file>..\pyvolution\shallow_water.py</file>
+    <file>..\pyvolution\shallow_water_ext.c</file>
+    <file>..\pyvolution\show_balanced_limiters.py</file>
+    <file>..\pyvolution\sparse.py</file>
+    <file>..\pyvolution\sparse_ext.c</file>
+    <file>..\pyvolution\test_advection.py</file>
+    <file>..\pyvolution\test_all.py</file>
+    <file>..\pyvolution\test_cg_solve.py</file>
+    <file>..\pyvolution\test_combine_pts.py</file>
+    <file>..\pyvolution\test_data_manager.py</file>
+    <file>..\pyvolution\test_domain.py</file>
+    <file>..\pyvolution\test_general_mesh.py</file>
+    <file>..\pyvolution\test_generic_boundary_conditions.py</file>
+    <file>..\pyvolution\test_interpolate_sww.py</file>
+    <file>..\pyvolution\test_least_squares.py</file>
+    <file>..\pyvolution\test_mesh.py</file>
+    <file>..\pyvolution\test_most2nc.py</file>
+    <file>..\pyvolution\test_pmesh2domain.py</file>
+    <file>..\pyvolution\test_quad.py</file>
+    <file>..\pyvolution\test_quantity.py</file>
+    <file>..\pyvolution\test_region.py</file>
+    <file>..\pyvolution\test_shallow_water.py</file>
+    <file>..\pyvolution\test_sparse.py</file>
+    <file>..\pyvolution\test_util.py</file>
+    <file>..\pyvolution\treenode.py</file>
+    <file>..\pyvolution\tsh2sww.py</file>
+    <file>..\pyvolution\twolevels.py</file>
+    <file>..\pyvolution\util.py</file>
+    <file>..\pyvolution\util_ext.c</file>
+    <file>..\pyvolution\util_ext.h</file>
+    <file>..\pyvolution\view_tsh.py</file>
+    <file>..\pyvolution\wind_example_variable.py</file>
+    <folder name="Header Files" />
+    <folder name="Resource Files" />
+    <folder name="Source Files" />
+</project>
Index: /inundation/zeus/steve.zpi
===================================================================
--- /inundation/zeus/steve.zpi	(revision 1727)
+++ /inundation/zeus/steve.zpi	(revision 1727)
@@ -0,0 +1,83 @@
+<!-- Project file for the Zeus for Windows editor.-->
+<project name="steve">
+    <SccEnable>On</SccEnable>
+    <SccComment></SccComment>
+    <SccProject></SccProject>
+    <SccAuxPath></SccAuxPath>
+    <SccLocalPath></SccLocalPath>
+    <TagEnable>On</TagEnable>
+    <TagNone>Off</TagNone>
+    <TagVariable>On</TagVariable>
+    <TagFunction>On</TagFunction>
+    <TagBuildNone>Off</TagBuildNone>
+    <TagBuildOnOpen>On</TagBuildOnOpen>
+    <TagBuildOnSave>On</TagBuildOnSave>
+    <TagInterval>6</TagInterval>
+    <Server></Server>
+    <UserID></UserID>
+    <Password></Password>
+    <LocalDir></LocalDir>
+    <RemoteDir></RemoteDir>
+    <Classes>Classes</Classes>
+    <Enumerations>Enumerations</Enumerations>
+    <Files>Project Files</Files>
+    <Functions>Functions</Functions>
+    <Interfaces>Interfaces</Interfaces>
+    <Macros>Macros</Macros>
+    <Packages>Packages</Packages>
+    <References>References</References>
+    <Structures>Structures</Structures>
+    <Typedefs>Typedefs</Typedefs>
+    <Variables>Variables</Variables>
+    <MakeFile>makefile</MakeFile>
+    <SearchPath></SearchPath>
+    <RegexFile></RegexFile>
+    <RegexLine></RegexLine>
+    <RegexInfo></RegexInfo>
+    <RegexError></RegexError>
+    <RegexWarning></RegexWarning>
+    <DebugExecutable></DebugExecutable>
+    <DebugArguments></DebugArguments>
+    <DebugDirectory></DebugDirectory>
+    <DebugDebugger></DebugDebugger>
+    <ReleaseExecutable></ReleaseExecutable>
+    <ReleaseArguments></ReleaseArguments>
+    <ReleaseDirectory></ReleaseDirectory>
+    <ReleaseDebugger></ReleaseDebugger>
+    <DebugMake>make $PF</DebugMake>
+    <DebugClean>make clean</DebugClean>
+    <DebugCompile></DebugCompile>
+    <DebugRebuild>make $PF</DebugRebuild>
+    <DebugProjectOutput>Always</DebugProjectOutput>
+    <DebugCompilerOutput>Always</DebugCompilerOutput>
+    <DebugCompilerStdOut>On</DebugCompilerStdOut>
+    <DebugCompilerStdErr>On</DebugCompilerStdErr>
+    <DebugCompilerSaveAll>Off</DebugCompilerSaveAll>
+    <DebugCompilerReload>Off</DebugCompilerReload>
+    <DebugProjectStdOut>On</DebugProjectStdOut>
+    <DebugProjectStdErr>On</DebugProjectStdErr>
+    <DebugProjectSaveAll>Off</DebugProjectSaveAll>
+    <DebugProjectReload>Off</DebugProjectReload>
+    <ReleaseMake>make $ws</ReleaseMake>
+    <ReleaseClean>make clean</ReleaseClean>
+    <ReleaseCompile></ReleaseCompile>
+    <ReleaseRebuild>rebuild $ws</ReleaseRebuild>
+    <ReleaseProjectOutput>Always</ReleaseProjectOutput>
+    <ReleaseCompilerOutput>Always</ReleaseCompilerOutput>
+    <ReleaseCompilerStdOut>On</ReleaseCompilerStdOut>
+    <ReleaseCompilerStdErr>On</ReleaseCompilerStdErr>
+    <ReleaseCompilerSaveAll>Off</ReleaseCompilerSaveAll>
+    <ReleaseCompilerReload>Off</ReleaseCompilerReload>
+    <ReleaseProjectStdOut>On</ReleaseProjectStdOut>
+    <ReleaseProjectStdErr>On</ReleaseProjectStdErr>
+    <ReleaseProjectSaveAll>Off</ReleaseProjectSaveAll>
+    <ReleaseProjectReload>Off</ReleaseProjectReload>
+    <file>..\steve\get_triangle_attribute.py</file>
+    <file>..\steve\get_triangle_data.py</file>
+    <file>..\steve\get_triangle_data_new.py</file>
+    <file>..\hobart\run_hobart_buildings.py</file>
+    <file>..\pyvolution-parallel\vtk-pylab.py</file>
+    <folder name="Header Files" />
+    <folder name="Resource Files" />
+    <folder name="Source Files" />
+</project>