Index: /inundation/validation/Incomplete/Merimbula/plane_beach.py.py
===================================================================
--- /inundation/validation/Incomplete/Merimbula/plane_beach.py.py	(revision 1769)
+++ /inundation/validation/Incomplete/Merimbula/plane_beach.py.py	(revision 1769)
@@ -0,0 +1,172 @@
+"""Example of shallow water wave equation.
+
+This is called Netherlands because it shows a dam with a gap in it and
+stylised housed behind it and below the water surface.
+
+"""
+
+######################
+# Module imports
+#
+#import rpdb
+#rpdb.set_active()
+
+from shallow_water import Domain, Reflective_boundary, Dirichlet_boundary,\
+     Transmissive_boundary, Constant_height, Constant_stage
+
+from mesh_factory import rectangular
+from Numeric import array
+
+
+class Weir:
+    """Set a bathymetry for simple weir with a hole.
+    x,y are assumed to be in the unit square
+    """
+
+    def __init__(self, stage):
+        self.inflow_stage = stage
+
+    def __call__(self, x, y):
+        from Numeric import zeros, Float
+
+        N = len(x)
+        assert N == len(y)
+
+        z = zeros(N, Float)
+        for i in range(N):
+            z[i] = -x[i]/20  #General slope
+
+            #Flattish bit to the left
+            if x[i] <= 0.3:
+                #z[i] = -x[i]/5
+                z[i] = -x[i]/20
+
+
+            #Weir
+            #if x[i] > 0.3 and x[i] < 0.4:***
+                #z[i] = -x[i]/20+1.2***
+
+            #Dip
+            #if x[i] > 0.6 and x[i] < 0.9:
+            #    z[i] = -x[i]/20-0.5  #-y[i]/5
+
+            #Hole in weir
+            #if x[i] > 0.3 and x[i] < 0.4 and y[i] > 0.2 and y[i] < 0.4:
+            #if x[i] > 0.3 and x[i] < 0.4 and y[i] > 0.4 and y[i] < 0.6:***
+                #z[i] = -x[i]/5
+                #z[i] = -x[i]/20***
+
+            #Poles
+            #if x[i] > 0.65 and x[i] < 0.8 and y[i] > 0.55 and y[i] < 0.65 or\
+            #       x[i] > 0.75 and x[i] < 0.9 and y[i] > 0.35 and y[i] < 0.45:
+            #    z[i] = -x[i]/20+0.4
+
+            if (x[i] - 0.72)**2 + (y[i] - 0.6)**2 < 0.05**2:# or\
+                   #x[i] > 0.75 and x[i] < 0.9 and y[i] > 0.35 and y[i] < 0.45:
+                z[i] = -x[i]/20+0.4
+
+
+            #Wall
+            if x[i] > 0.995:
+                z[i] = -x[i]/20+0.3
+
+        return z/2
+
+
+
+######################
+# Domain
+#
+
+
+N = 150 #size = 45000
+N = 130 #size = 33800
+N = 600 #Size = 720000
+N = 60
+
+
+#N = 15
+
+print 'Creating domain'
+#Create basic mesh
+points, vertices, boundary = rectangular(N, N)
+
+#Create shallow water domain
+domain = Domain(points, vertices, boundary, use_inscribed_circle=True)
+
+domain.check_integrity()
+domain.default_order = 2
+#domain.beta_h=0
+
+#Output params
+domain.smooth = True #Changed from False (the original condition)
+domain.reduction = min  #Looks a lot better on top of steep slopes
+
+print "Number of triangles = ", len(domain)
+
+#Set bed-slope and friction
+inflow_stage = 0.1
+manning = 0.03
+Z = Weir(inflow_stage)
+
+if N > 50:
+    domain.visualise = False
+    domain.checkpoint = False
+    domain.store = True    #Store for visualisation purposes
+    domain.format = 'sww'   #Native netcdf visualisation format
+    import sys, os
+    #FIXME: This was os.path.splitext but caused weird filenames based on root
+    base = os.path.basename(sys.argv[0])
+    domain.filename, _ = os.path.splitext(base)
+else:
+    domain.initialise_visualiser(rect=[0.0,0.0,1.0,1.0])
+    domain.visualiser.coloring['stage'] = True
+    domain.visualise_timer = True
+    domain.checkpoint = False
+    domain.store = False
+
+
+
+
+print 'Field values'
+domain.set_quantity('elevation', Z)
+domain.set_quantity('friction', manning)
+
+
+######################
+# Boundary conditions
+#
+print 'Boundaries'
+Br = Reflective_boundary(domain)
+Bt = Transmissive_boundary(domain)
+
+#Constant inflow
+Bd = Dirichlet_boundary([inflow_stage, 0.0, 0.0])
+
+
+#Set boundary conditions
+domain.set_boundary({'left': Bd, 'right': Br, 'bottom': Br, 'top': Br})
+
+
+######################
+#Initial condition
+#
+print 'Initial condition'
+domain.set_quantity('stage', Constant_height(Z, 0.0))
+#domain.set_quantity('stage', Constant_stage(-1.0))
+
+#Evolve
+import time
+t0 = time.time()
+
+
+
+for t in domain.evolve(yieldstep = 0.1, finaltime = 15.0):
+    domain.write_time()
+    #rpdb.set_active()
+    #domain.visualiser.scale_z = 1.0
+    #domain.visualiser.update_quantity_color('xmomentum',scale_z = 4.0)
+    #integral_label.text='Integral=%10.5e'%domain.quantities['stage'].get_integral()
+
+
+print 'That took %.2f seconds' %(time.time()-t0)
Index: undation/validation/plane_beach.py.py
===================================================================
--- /inundation/validation/plane_beach.py.py	(revision 1768)
+++ 	(revision )
@@ -1,172 +1,0 @@
-"""Example of shallow water wave equation.
-
-This is called Netherlands because it shows a dam with a gap in it and
-stylised housed behind it and below the water surface.
-
-"""
-
-######################
-# Module imports
-#
-#import rpdb
-#rpdb.set_active()
-
-from shallow_water import Domain, Reflective_boundary, Dirichlet_boundary,\
-     Transmissive_boundary, Constant_height, Constant_stage
-
-from mesh_factory import rectangular
-from Numeric import array
-
-
-class Weir:
-    """Set a bathymetry for simple weir with a hole.
-    x,y are assumed to be in the unit square
-    """
-
-    def __init__(self, stage):
-        self.inflow_stage = stage
-
-    def __call__(self, x, y):
-        from Numeric import zeros, Float
-
-        N = len(x)
-        assert N == len(y)
-
-        z = zeros(N, Float)
-        for i in range(N):
-            z[i] = -x[i]/20  #General slope
-
-            #Flattish bit to the left
-            if x[i] <= 0.3:
-                #z[i] = -x[i]/5
-                z[i] = -x[i]/20
-
-
-            #Weir
-            #if x[i] > 0.3 and x[i] < 0.4:***
-                #z[i] = -x[i]/20+1.2***
-
-            #Dip
-            #if x[i] > 0.6 and x[i] < 0.9:
-            #    z[i] = -x[i]/20-0.5  #-y[i]/5
-
-            #Hole in weir
-            #if x[i] > 0.3 and x[i] < 0.4 and y[i] > 0.2 and y[i] < 0.4:
-            #if x[i] > 0.3 and x[i] < 0.4 and y[i] > 0.4 and y[i] < 0.6:***
-                #z[i] = -x[i]/5
-                #z[i] = -x[i]/20***
-
-            #Poles
-            #if x[i] > 0.65 and x[i] < 0.8 and y[i] > 0.55 and y[i] < 0.65 or\
-            #       x[i] > 0.75 and x[i] < 0.9 and y[i] > 0.35 and y[i] < 0.45:
-            #    z[i] = -x[i]/20+0.4
-
-            if (x[i] - 0.72)**2 + (y[i] - 0.6)**2 < 0.05**2:# or\
-                   #x[i] > 0.75 and x[i] < 0.9 and y[i] > 0.35 and y[i] < 0.45:
-                z[i] = -x[i]/20+0.4
-
-
-            #Wall
-            if x[i] > 0.995:
-                z[i] = -x[i]/20+0.3
-
-        return z/2
-
-
-
-######################
-# Domain
-#
-
-
-N = 150 #size = 45000
-N = 130 #size = 33800
-N = 600 #Size = 720000
-N = 60
-
-
-#N = 15
-
-print 'Creating domain'
-#Create basic mesh
-points, vertices, boundary = rectangular(N, N)
-
-#Create shallow water domain
-domain = Domain(points, vertices, boundary, use_inscribed_circle=True)
-
-domain.check_integrity()
-domain.default_order = 2
-#domain.beta_h=0
-
-#Output params
-domain.smooth = True #Changed from False (the original condition)
-domain.reduction = min  #Looks a lot better on top of steep slopes
-
-print "Number of triangles = ", len(domain)
-
-#Set bed-slope and friction
-inflow_stage = 0.1
-manning = 0.03
-Z = Weir(inflow_stage)
-
-if N > 50:
-    domain.visualise = False
-    domain.checkpoint = False
-    domain.store = True    #Store for visualisation purposes
-    domain.format = 'sww'   #Native netcdf visualisation format
-    import sys, os
-    #FIXME: This was os.path.splitext but caused weird filenames based on root
-    base = os.path.basename(sys.argv[0])
-    domain.filename, _ = os.path.splitext(base)
-else:
-    domain.initialise_visualiser(rect=[0.0,0.0,1.0,1.0])
-    domain.visualiser.coloring['stage'] = True
-    domain.visualise_timer = True
-    domain.checkpoint = False
-    domain.store = False
-
-
-
-
-print 'Field values'
-domain.set_quantity('elevation', Z)
-domain.set_quantity('friction', manning)
-
-
-######################
-# Boundary conditions
-#
-print 'Boundaries'
-Br = Reflective_boundary(domain)
-Bt = Transmissive_boundary(domain)
-
-#Constant inflow
-Bd = Dirichlet_boundary([inflow_stage, 0.0, 0.0])
-
-
-#Set boundary conditions
-domain.set_boundary({'left': Bd, 'right': Br, 'bottom': Br, 'top': Br})
-
-
-######################
-#Initial condition
-#
-print 'Initial condition'
-domain.set_quantity('stage', Constant_height(Z, 0.0))
-#domain.set_quantity('stage', Constant_stage(-1.0))
-
-#Evolve
-import time
-t0 = time.time()
-
-
-
-for t in domain.evolve(yieldstep = 0.1, finaltime = 15.0):
-    domain.write_time()
-    #rpdb.set_active()
-    #domain.visualiser.scale_z = 1.0
-    #domain.visualiser.update_quantity_color('xmomentum',scale_z = 4.0)
-    #integral_label.text='Integral=%10.5e'%domain.quantities['stage'].get_integral()
-
-
-print 'That took %.2f seconds' %(time.time()-t0)