Index: /production/karratha_2005/create_mesh.py
===================================================================
--- /production/karratha_2005/create_mesh.py	(revision 1795)
+++ /production/karratha_2005/create_mesh.py	(revision 1796)
@@ -8,5 +8,8 @@
 from pmesh.mesh import *
 from pyvolution.coordinate_transforms.geo_reference import Geo_reference
-from pyvolution.coordinate_transforms.redfearn import redfearn, degminsec2decimal_degrees
+from pyvolution.coordinate_transforms.redfearn import redfearn
+
+
+import project
 
 #-------------------------------------------------------------
@@ -14,11 +17,13 @@
 
 
-    refzone = 50
+    
     #Basic geometry
 
-    south = degminsec2decimal_degrees(-20,45,0)
-    north = degminsec2decimal_degrees(-20,15,0)
-    west = degminsec2decimal_degrees(116,30,0)
-    east = degminsec2decimal_degrees(117,0,0)        
+    south = project.south 
+    north = project.north
+    west = project.west
+    east = project.east
+
+    refzone = project.refzone
 
 
@@ -76,5 +81,4 @@
     m.generateMesh('pzq28.0za1000000a')
 
-    import project
     m.export_mesh_file(project.meshname + '.msh')
     
Index: /production/karratha_2005/prepare_boundary.py
===================================================================
--- /production/karratha_2005/prepare_boundary.py	(revision 1795)
+++ /production/karratha_2005/prepare_boundary.py	(revision 1796)
@@ -21,15 +21,25 @@
 from pyvolution.data_manager import ferret2sww
 
-#Origin of existing tsh file (Temporary measure)
-mesh_origin = (56,308500.000000,6189000.000000) 
+
+south = project.south 
+north = project.north
+west = project.west
+east = project.east
+
+
+#Origin of existing dem (Temporary measure)
+mesh_origin = (50, 421544.35127423, 7677669.5257159)
+
+    
 
 ferret2sww(source_dir+project.boundary_basename,
            project.boundary_basename, 
            verbose=True,
-           minlat=-35, maxlat=-34,
-           minlon=150.5, maxlon=152,
+           minlat=south-1, maxlat=north+1,
+           minlon=west-1, maxlon=east+1,
            origin = mesh_origin,
            zscale = 1,
-           fail_on_NaN = False),
+           fail_on_NaN = False,
+           inverted_bathymetry = True),
 
 
Index: /production/karratha_2005/project.py
===================================================================
--- /production/karratha_2005/project.py	(revision 1795)
+++ /production/karratha_2005/project.py	(revision 1796)
@@ -10,5 +10,5 @@
 
 meshdir = home+sep+'karratha_tsunami_scenario_2005'+sep+'meshes'+sep
-datadir = home+sep+'karratha_tsunami_scenario_2005'+sep+'data'+sep
+datadir = home+sep+'karratha_tsunami_scenario_2005'+sep+'topographies'+sep
 outputdir = home+sep+'karratha_tsunami_scenario_2005'+sep+'output'+sep
 boundarydir = home+sep+'karratha_tsunami_scenario_2005'+sep+'boundaries'+sep
@@ -18,6 +18,16 @@
 meshname = meshdir + basename
 demname = datadir + basename
+boundaryname = boundarydir + 'SU-AU'
 
 boundary_basename = 'SU-AU'
 
+#Georeferencing
+from pyvolution.coordinate_transforms.redfearn import degminsec2decimal_degrees
 
+south = degminsec2decimal_degrees(-20,45,0)
+north = degminsec2decimal_degrees(-20,15,0)
+west = degminsec2decimal_degrees(116,30,0)
+east = degminsec2decimal_degrees(117,0,0)
+
+
+refzone = 50
Index: /production/karratha_2005/run_karratha.py
===================================================================
--- /production/karratha_2005/run_karratha.py	(revision 1795)
+++ /production/karratha_2005/run_karratha.py	(revision 1796)
@@ -8,17 +8,18 @@
 
 from pyvolution.shallow_water import Domain, Reflective_boundary
-from pyvolution.data_manager import convert_dem_from_ascii2netcdf, dem2pts
+from pyvolution.data_manager import convert_dem_from_ascii2netcdf,\
+     dem2pts, ferret2sww
 from pyvolution.pmesh2domain import pmesh_to_domain_instance 
 from caching import cache
 import project
 
+#Data preparation
 #Convert ASC 2 DEM 2 PTS using source data and store result in source data
-
 demname = project.demname
-
 
 cache(convert_dem_from_ascii2netcdf, demname, {'verbose': True},
       dependencies = [demname + '.asc'],
       verbose = True)
+      #evaluate = True)
 
 cache(dem2pts, demname, {'verbose': True},
@@ -26,5 +27,11 @@
       verbose = True)
 
+#Convert MOST boundary
 
+ferret2sww('test', verbose=False,
+           origin = (56, 0, 0))
+
+
+#Read mesh
 mesh = project.meshname + '.msh'
 domain = cache(pmesh_to_domain_instance, (mesh, Domain),
@@ -39,4 +46,5 @@
 print "Number of triangles = ", len(domain)
 print 'The extent is ', domain.get_extent()
+
 
 #IC